<template>
    <div class="">
        <div class="columns twelve loan-history"
             :class="[$interface.viewport === 'desktop' ? 'container' : '',
                 $interface.viewport === 'laptop' ? 'container' : '']">
            <h3 class="main-header">Кредитный рейтинг</h3>
            <CreditRatingResult v-if="showCreditRatingData"
                                v-bind="{
                                    showCreditRatingData,
                                }"
                                @toHistory="toHistory"
            />
            <div v-else class="credit-rating-history">
                <loader ref="loader"
                        v-bind="{
                            name: 'creditHistory',
                            isShow: isCreditRatingLoad,
                            waitingTitle: 'Загругка кредитного рейтинга',
                            caption: '',
                        }"
                />
                <div class="credit-rating-history__wrapper">
                    <div class="credit-rating-history__header">
                        <h6 class="credit-rating-history__header-title" >История запросов</h6>
                        <button class="credit-rating-history__header-button"
                                @click="$emit('ratingRequest')"
                        >
                            <SVGIcon viewBox="0 0 45 45" xlink="new-rating-icon"/>
                            <span class="link">Запросить рейтинг</span>
                        </button>
                    </div>
                    <div class="credit-rating-history__content">
                        <div class="credit-rating-history__table">
                            <div class='white-block'>
                                <div class='padding table-header'>
                                    <div class='row'>
                                        <div :class="['columns', 'three', 'center', 'sum', {'top-arrow': sortOrder.num === 'ASC'}]"
                                             @click="runSort('num')">
                                            Номер отчета
                                        </div>
                                        <div :class="['columns', 'three', 'center', 'sum', {'top-arrow': sortOrder.date === 'ASC'}]"
                                             @click="runSort('date')">
                                            Дата создания
                                        </div>
                                        <div :class="['columns', 'three', 'center', 'sum', {'top-arrow': sortOrder.status === 'ASC'}]"
                                             @click="runSort('status', 'status')">
                                            Статус отчета
                                        </div>
                                        <div class='columns two center'>
                                            Документы
                                        </div>
                                    </div>
                                </div>
                                <credit-list-row v-for='ratingRequest in creditRatingRequestsHistory'
                                                 :key="ratingRequest.id"
                                                 v-bind="{
                                                   ratingRequest,
                                                 }"
                                                 class="list-item"
                                                 @showCreditRating="showCreditRating"
                                />
                            </div>
                            <div class='center' v-if="storeCreditRatingState.creditRatingRequestsHistory.length > limitItems" style="margin-top: 40px;">
                                <button class='white' @click="showMoreRatingRequests">Показать ещё</button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
	import Loader from '@/components/Loader'
	import SVGIcon from '@/components/SVGIcon'
	import CreditListRow from './ListRow'
	import CreditRatingResult from './CreditRating/'

	export default {
		name: 'CreditHistory',
		components: {
			Loader,
			SVGIcon,
			CreditListRow,
			CreditRatingResult
		},
		data() {
			return {
				sortOrder: {
					num: 'ASC',
					date: 'ASC',
					status: 'ASC'
				},
				limitItems: 5,
				creditHistoryRequests: [],
				isCreditRatingLoad: false,
				showCreditRatingData: null,
				lastScroll: 0,
			};
		},
		computed: {
			storeCreditRatingState() {
				return this.$store.state.creditRating;
			},
			creditRatingRequestsHistory() {
			    const list = JSON.parse(JSON.stringify(this.storeCreditRatingState.creditRatingRequestsHistory));
				return list.slice(0, this.limitItems);
			},
		},

		methods: {
			showMoreRatingRequests() {
				this.limitItems += 5;
			},
			async showCreditRating(guid) {
				this.lastScroll = window.scrollY;
				this.isCreditRatingLoad = true;
				const creditRatingData = await this.$backend.api.services.cr.guid(guid)
					.then(({data}) => {
						return data.data;
					})
					.catch(() => {
						this.$toastr.error('Ошибка при запросе кредитного рейтинга');
					});
				this.isCreditRatingLoad = false;
				if(!creditRatingData) {
					return;
				}
				this.showCreditRatingData = creditRatingData;
			},
			toHistory() {
				this.showCreditRatingData = null;
				this.$nextTick(() => {
					/*вернуться в позицию из истории запросов которой был осуществлён переход*/
					window.scrollTo(0, this.lastScroll);
				});
			},
			runSort(type, mode = 'default') {
				if (this.creditRatingRequestsHistory.length <= 0) {
					return
				}
				/*
				В зависмости от типа сортировки определяем модификатор. Если сортировка по возрастанию, то модификатор 1.
				Если по убыванию - модификатор минус 1
				 */
				const modificator = this.sortOrder[type] === 'ASC' ? 1 : -1
				/*
				Обычная функция сортировки. Применяется для сортирови по названию, дате и сумме займа
				 */
				const defaultCompare = (a, b) => {
					if (a[type] > b[type]) {
						return modificator
					}
					if (a[type] < b[type]) {
						return -1 * modificator
					}
					return 0
				}
				/*
				Функция сортировки по статусу займа
				 */
				const statusCompare = (a, b) => {
					let priorityA = a.status;
					let priorityB = b.status;
					if (priorityA > priorityB) {
						return modificator
					}
					if (priorityA < priorityB) {
						return -1 * modificator
					}
					return 0
				}
				/*
				Сортируем элементы
				 */
				let compare = mode === 'status' ? statusCompare : defaultCompare
				this.creditRatingRequestsHistory.sort(compare)
				const objKeys = Object.keys(this.sortOrder)
				objKeys.forEach((value) => {
					if (value !== type) {
						// Обнуляем параметры сортировки для всех столбцов, кроме того, по которому проводим сортировку
						this.sortOrder[value] = 'ASC'
					}
				})
				// Для столбца, по которому производили сортировку, изменяем параметры сортировки
				this.sortOrder[type] = this.sortOrder[type] === 'ASC' ? 'DESC' : 'ASC'
			},
		},
		created() {
			this.AJAX_LOADING(false);
		},
	}
</script>

<style scoped lang="scss">
    .credit-rating-history {
        position: relative;
    }
    .white-block {
        border: none;
    }
    div.sum {
        background: url("/lk/static/img/history/arrow.png") no-repeat 100% 5px;
        padding-right: 15px;
        cursor: pointer;
    }

    div.sum.top-arrow {
        background-position: 100% -90px
    }
</style>
